﻿local _, ns = ...

local C = ns.C
local L = ns.L

DefaultDB = {
	big = true,
	name = true,
	texture = true,
	daduan = true,
	arrow = true,
	ch = true,
	mytarget = true,
	sf = true,
	pvp = true,
	boom = false,
	white= false,
	casttime = true,
	nameonly = true,
	
	
	auto = true,
	killtexture = true,
	bufftext = true,
	po = true,
	hpcent = false,
	DetailType = 3,
	
	namefont = 12,
	num = 1,
	mypotext = 1,
	KillPer = 0,

	hidebuff = false,
	
	blacklist = false,
	
	myplatebuff = true,
	buffz = 25,
	buffoffset = 0,
	SelfScale = 1,
	
	nScale = 0.7,
	tScale = 1,
	ov = 0.8,
	oh = 0.6,
	AlphaMult = 1,
	MaxAlpha = 1,
	
color = {
	["rgb0"] = {r=1, g=0, b=0}, 
    ["rgb1"] = {r=1, g=0, b=0}, 
    ["rgb2"] = {r=0.3, g=0, b=0.6},
	["rgb3"] = {r=0.2, g=0.3, b=0.6},
	["rgb4"] = {r=1, g=0.5, b=0},
	["rgb5"] = {r=0, g=1, b=1},
	["rgb6"] = {r=0, g=1, b=0},
	["rgb7"] = {r=1, g=0, b=1},
},

DctAura = {	
	--[307443] = true,	--璀璨火花
	--[307454] = true, 	--璀璨火花易伤

	},
blackAura = {	
	--[307443] = true,	--璀璨火花--黑名单示范

	},
}


----------ONLOAD EVENT---------
local loadFrame = CreateFrame("FRAME"); 
loadFrame:RegisterEvent("ADDON_LOADED"); 
loadFrame:RegisterEvent("PLAYER_LOGOUT"); 

function loadFrame:OnEvent(event, arg1)
	if not PlateColorDB then PlateColorDB = {} end
	for i, j in pairs(DefaultDB) do
		if type(j) == "table" then
			if PlateColorDB[i] == nil then PlateColorDB[i] = {} end
			for k, v in pairs(j) do
				if PlateColorDB[i][k] == nil then
					PlateColorDB[i][k] = v
				end
			end
		else
			if PlateColorDB[i] == nil then PlateColorDB[i] = j end
		end
	end
end
loadFrame:SetScript("OnEvent", loadFrame.OnEvent);
----------------------------------
--进入游戏时加载一些配置
local uicvars = CreateFrame("Frame")
uicvars:RegisterEvent("PLAYER_ENTERING_WORLD")
uicvars:HookScript("OnEvent", function(self, event)

SetCVar("nameplateGlobalScale", PlateColorDB.nScale)
SetCVar("nameplateSelectedScale", PlateColorDB.tScale)
SetCVar("nameplateLargerScale", PlateColorDB.tScale)
SetCVar("nameplateOverlapV", PlateColorDB.ov)
SetCVar("nameplateOverlapH", PlateColorDB.oh)
SetCVar("nameplateOccludedAlphaMult", PlateColorDB.AlphaMult)
SetCVar("nameplateMaxAlpha", PlateColorDB.MaxAlpha)
SetCVar("nameplateMinAlpha", PlateColorDB.MaxAlpha)
SetCVar("nameplateSelfScale", PlateColorDB.SelfScale)

SetCVar("nameplateShowOnlyNames", 0) --关闭仅显示名字模式
SetCVar("namePlateMinScale", 1)	--距离缩放
SetCVar("namePlateMaxScale", 1)	--距离缩放

--姓名版始终保持在屏幕内
SetCVar("nameplateOtherTopInset", 0.08)
SetCVar("nameplateOtherBottomInset", 0.1)
SetCVar("nameplateLargeTopInset", 0.08)
SetCVar("nameplateLargeBottomInset", 0.1)

if PlateColorDB.nameonly then --友方相关
SetCVar("nameplateShowDebuffsOnFriendly", 0)--不显示友方debuff
C_NamePlate.SetNamePlateFriendlySize(25,-45)--友方血条缩小
end

--字体
local fontline = nil
if PlateColorDB.name == true then
fontline = "OUTLINE"
else
fontline = nil
end
local function SetFont(obj, optSize) 
	local fontName, _,fontFlags  = obj:GetFont() 
	obj:SetFont(fontName,optSize,fontline) 
	obj:SetShadowOffset(0, 0) 
end
SetFont(SystemFont_LargeNamePlate,PlateColorDB.namefont)
SetFont(SystemFont_NamePlate,PlateColorDB.namefont) 
SetFont(SystemFont_LargeNamePlateFixed,PlateColorDB.namefont) 
SetFont(SystemFont_NamePlateFixed,PlateColorDB.namefont) 
SetFont(SystemFont_NamePlateCastBar,PlateColorDB.namefont)

if PlateColorDB.big == true then --第一次使用设置大姓名版
SetCVar("NamePlateHorizontalScale", 1.4)	--大姓名版
SetCVar("NamePlateVerticalScale", 2.7)	--大姓名版
PlateColorDB.big = false
end
end)

--材质
local function bartexture(unitFrame)
if PlateColorDB.texture == true then
local bars=NamePlateDriverFrame:GetClassNameplateManaBar() 
if bars then bars:SetStatusBarTexture(.9,.9,.9) end
unitFrame.healthBar:SetStatusBarTexture(.75,.75,.75)
end
end

--斩杀分割线
local zhansha = 0 --斩杀变色和斩杀分割线用
local function barkillper(unitFrame)
local width = unitFrame.healthBar:GetWidth()
local height = unitFrame.healthBar:GetHeight()
local fsid,_,_,_,_,_,_,_,_,fsidtf = GetTalentInfo(1,3,1)	--法师判断第一行第三个天赋
local zsid,_,_,_,_,_,_,_,_,zsidtf = GetTalentInfo(3,1,1)	--战士3行1天赋斩杀35
if PlateColorDB.auto == true then
	if IsSpellKnown(281000) or IsSpellKnown(280735) or IsSpellKnown(330334) or IsSpellKnown(330325) or IsSpellKnown(343294) or ((zsid == 22380 or zsid ==22379 ) and zsidtf) then
	--281000武器斩杀35,280735狂暴斩杀35,330334武器判罪35,330325狂暴判罪35,343294邪DK灵魂收割,173243奥法弹幕橙or IsEquippedItem(173243) 战士35zsid == 22380 or zsid ==22379
	zhansha = 35
	elseif fsid == 22462 and fsidtf == true then	--灼烧之触
	zhansha = 30
	elseif IsSpellKnown(24275) or IsSpellKnown(163201) or IsSpellKnown(5308) or IsSpellKnown(32379) or IsSpellKnown(53351) or IsSpellKnown(320976) or IsSpellKnown(317349) or IsSpellKnown(317485) then
	--24275愤怒之锤,163201武器防斩杀20,5308狂暴斩杀20,32379牧师灭,53351兽王射击夺命,320976生存夺命,317349武器防判罪20,317485狂暴判罪20
	zhansha = 20
	--elseif IsSpellKnown(322109) then	--轮回之触
	--zhansha = 15
	else
	zhansha = 0
	end
else
	zhansha = PlateColorDB.KillPer
end
if not unitFrame.killline then
	unitFrame.killline = unitFrame.healthBar:CreateTexture(nil, "OVERLAY")
	unitFrame.killline:SetSize(2, height)	
	unitFrame.killline:SetTexture("Interface\\Buttons\\WHITE8x8")
else
	unitFrame.killline:SetPoint("LEFT",unitFrame.healthBar,"LEFT",zhansha*width/100, 0)
	if zhansha == 0 or PlateColorDB.killtexture == false or C_NamePlate.GetNamePlateForUnit(unitFrame.unit) == C_NamePlate.GetNamePlateForUnit("player")
	then unitFrame.killline:Hide() else unitFrame.killline:Show() end
end
end
--名字变色
local function platenamecolor(unitFrame)
if unitFrame:IsForbidden() then return end
if UnitIsPlayer(unitFrame.unit) then return end
if UnitIsTapDenied(unitFrame.unit)  then return end
if unitFrame.unit:lower():match("nameplate") then
local guid = UnitGUID(unitFrame.unit)
local _, _, _, _, _, id = strsplit("-", guid or "") 
local _,_,_,_,_,_,_,_,_,buff1 = UnitBuff(unitFrame.unit,1)
local _,_,_,_,_,_,_,_,_,buff2 = UnitBuff(unitFrame.unit,2)
local _,_,_,_,_,_,_,_,_,buff3 = UnitBuff(unitFrame.unit,3)
local _,_,_,_,_,_,_,_,_,buff4 = UnitBuff(unitFrame.unit,4)
if id == "5925" or id == "105451" or id == "105427" or id == "61245" then	--图腾
	unitFrame.healthBar:SetHeight(30)
end
if id == "165108" then	--仙林BOSS小怪
	unitFrame.healthBar:SetHeight(8)
	unitFrame.name:Hide()
end
if id == "174773" or id=="126023" then --怨毒
unitFrame.name:SetTextColor(PlateColorDB.color.rgb6.r,PlateColorDB.color.rgb6.g,PlateColorDB.color.rgb6.b,1)
elseif (buff1 or buff2 or buff3 or buff4) == 343502 then --鼓舞
unitFrame.name:SetTextColor(PlateColorDB.color.rgb6.r,PlateColorDB.color.rgb6.g,PlateColorDB.color.rgb6.b,1)
elseif PlateColorDB.white then
unitFrame.name:SetVertexColor(1, 1, 1)
end

end
end

--调用
local namepoint = CreateFrame("Frame")
namepoint:RegisterEvent("NAME_PLATE_UNIT_ADDED")
namepoint:SetScript("OnEvent", function(self, event,frame)
local namePlate = C_NamePlate.GetNamePlateForUnit(frame)
local unitFrame = namePlate.UnitFrame
bartexture(unitFrame)
barkillper(unitFrame)
platenamecolor(unitFrame)
end)
hooksecurefunc("CompactUnitFrame_UpdateName", platenamecolor)

--血条右侧显示箭头
hooksecurefunc("CompactUnitFrame_UpdateSelectionHighlight", function(frame)
if frame:IsForbidden() then return end
if frame.unit:lower():match("nameplate") then
	if not frame.arrow then
		frame.arrow = frame.healthBar:CreateTexture(nil, "PARENT")
		frame.arrow:SetTexture("Interface\\Addons\\PlateColor\\blue.tga")		-- 图标路径
		frame.arrow:SetPoint("right", frame.healthBar, "right", 45, 0)				-- 右方箭头位置
		frame.arrow:SetSize(50, 50)										-- 箭头大小
		frame.arrow:Hide()
	end
	if UnitIsUnit(frame.displayedUnit, "target") and PlateColorDB.arrow ==  true then
		frame.arrow:Show()
	else
		frame.arrow:Hide()
	end
	if UnitIsUnit("player", frame.unit) and frame.arrow then
		frame.arrow:Hide()
	end
end
end)

--血条变色
local barcolor = CreateFrame("Frame")
barcolor:RegisterEvent("NAME_PLATE_UNIT_ADDED")
barcolor:RegisterEvent("UNIT_THREAT_LIST_UPDATE")
barcolor:RegisterEvent("PLAYER_TARGET_CHANGED")
barcolor:RegisterEvent("UNIT_HEALTH")
barcolor:SetScript("OnEvent", function(self, event,frame)
for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
local unitFrame = namePlate.UnitFrame
if unitFrame:IsForbidden() then return end
if not UnitIsPlayer(unitFrame.unit) and not UnitIsTapDenied(unitFrame.unit) and C_NamePlate.GetNamePlateForUnit(unitFrame.unit) ~= C_NamePlate.GetNamePlateForUnit("player") then
	local threat = UnitThreatSituation("player", unitFrame.unit) or 0
	local reaction = UnitReaction(unitFrame.unit, "player")
	local name = UnitName(unitFrame.unit)
	local me = UnitName("player")
	local pt = UnitIsUnit(unitFrame.unit.."target", me)
	local Cur = UnitHealth(unitFrame.unit)
	local Max = UnitHealthMax(unitFrame.unit)
	local Per = Cur/Max*100 or 0
	local guid = UnitGUID(unitFrame.unit)
	local _, _, _, _, _, id = strsplit("-", guid or "") 
	local combat = UnitAffectingCombat(unitFrame.unit)
	    if id == "120651" or id == "118032" or id == "179733" or id == "183671" then --邪能炸药.179733鱼串,183671安度因大怪
			r, g, b = 0,1,0	--绿色
		elseif id == "185685" or id == "184911" then	
			r, g, b = 1,.4,1	--粉色--减CD
		elseif id == "185680" or id == "184908" then	
			r, g, b = .2,.4,0	--墨绿--急速
		elseif id == "185683" or id == "184910" then	
			r, g, b = 1,1,.6	--浅黄--隐身
		elseif ((id == "134389") or (id == "134390") or (id == "174773")or (id == "170483")) and pt == true and PlateColorDB.ch == true then
			r, g, b = PlateColorDB.color.rgb2.r,PlateColorDB.color.rgb2.g,PlateColorDB.color.rgb2.b	--目标是你但是无仇恨预警
		elseif threat == 3  and PlateColorDB.ch == true then
            r, g, b = PlateColorDB.color.rgb2.r,PlateColorDB.color.rgb2.g,PlateColorDB.color.rgb2.b	-- 仇恨是你 颜色
		elseif threat == 2 and PlateColorDB.ch == true then      
            r, g, b = PlateColorDB.color.rgb3.r,PlateColorDB.color.rgb3.g,PlateColorDB.color.rgb3.b	--仇恨降低  颜色
        elseif threat == 1 and PlateColorDB.ch == true then      
            r, g, b = PlateColorDB.color.rgb4.r,PlateColorDB.color.rgb4.g,PlateColorDB.color.rgb4.b	-- 高仇恨  颜色
		elseif Per <=  zhansha then 
			r, g, b = PlateColorDB.color.rgb7.r,PlateColorDB.color.rgb7.g,PlateColorDB.color.rgb7.b	--斩杀
		elseif UnitIsUnit(unitFrame.unit, "target") and PlateColorDB.mytarget == true then
			r, g, b = PlateColorDB.color.rgb5.r,PlateColorDB.color.rgb5.g,PlateColorDB.color.rgb5.b	-- 你的目标 颜色
		elseif combat == true then
			r, g, b = PlateColorDB.color.rgb1.r,PlateColorDB.color.rgb1.g,PlateColorDB.color.rgb1.b	--战斗状态
		elseif reaction == 4 then
			r, g, b = 1, 1, 0		-- 中立怪 黄色
		elseif reaction >= 5 then
			r, g, b = 0, 1, 0		-- 友方npc 绿色
        else
			r, g, b = PlateColorDB.color.rgb0.r,PlateColorDB.color.rgb0.g,PlateColorDB.color.rgb0.b
        end
unitFrame.healthBar:SetStatusBarColor(r, g, b, 1)
end
end
end)

---local mytime = C_Timer.NewTicker(0.1,function()
--施法目标
local casttarget = CreateFrame("Frame")
casttarget:RegisterEvent("NAME_PLATE_UNIT_ADDED")
casttarget:RegisterEvent("UNIT_TARGET")
casttarget:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")
casttarget:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
casttarget:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE")
casttarget:RegisterEvent("UNIT_SPELLCAST_DELAYED")
casttarget:RegisterEvent("UNIT_SPELLCAST_FAILED")
casttarget:RegisterEvent("UNIT_SPELLCAST_FAILED_QUIET")
casttarget:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")
casttarget:RegisterEvent("UNIT_SPELLCAST_INTERRUPTIBLE")
casttarget:RegisterEvent("UNIT_SPELLCAST_NOT_INTERRUPTIBLE")
casttarget:RegisterEvent("UNIT_SPELLCAST_START")
casttarget:RegisterEvent("UNIT_SPELLCAST_STOP")
casttarget:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
casttarget:SetScript("OnEvent", function(self, event)
for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
local frame = namePlate.UnitFrame
if frame then
local namea = UnitName(frame.unit.."target")
local myname = UnitName("Player")
local players = UnitIsPlayer(frame.unit)
local _, class = UnitClass(frame.unit.."target")
local guid = UnitGUID(frame.unit)
local _, _, _, _, _, id = strsplit("-", guid or "") 
color = CUSTOM_CLASS_COLORS and CUSTOM_CLASS_COLORS[class] or RAID_CLASS_COLORS[class]
if not frame.ta then
	frame.ta = frame.healthBar:CreateFontString(nil, "ARTWORK")
	frame.ta:SetFont(STANDARD_TEXT_FONT, 20, 'OUTLINE')
	frame.ta:SetPoint("LEFT",frame,"RIGHT",-60,15)
	frame.ta:Hide()
elseif PlateColorDB.sf == true and players == false then
	if ( UnitCastingInfo(frame.unit) ~= nil or UnitChannelInfo(frame.unit) ~= nil ) or id == "174773"  then	--and frame.ta:GetText() == myname then
		if color then frame.ta:SetTextColor(color.r, color.g, color.b) end
		frame.ta:SetText(namea)
		frame.ta:Show()
	else
		frame.ta:Hide()
	end
elseif PlateColorDB.pvp == true and players == true and UnitName(frame.unit) ~= UnitName("Player") then
	if color then frame.ta:SetTextColor(color.r, color.g, color.b) end
	frame.ta:SetText(namea)
	if frame.ta:GetText() == myname then
		frame.ta:Show()
	else
		frame.ta:Hide()
	end
else 
	frame.ta:Hide()
end
end
if UnitIsUnit("player", frame.unit) and frame.ta then
	frame.ta:Hide()
end
end
end)

--施法条计时
hooksecurefunc("CastingBarFrame_OnUpdate", function(self,elapsed)
if PlateColorDB.casttime == false then return end
if not frame then return end
if frame:IsForbidden() then return end
local frame = self:GetParent()
if frame.unit:lower():match("nameplate") then
	if not frame.castCooldown and frame.castBar then
	frame.castCooldown = frame.castBar:CreateFontString(nil)
    frame.castCooldown:SetFont(SystemFont_Outline_Small:GetFont(), 13, "OUTLINE")	--施法时间文字大小
    frame.castCooldown:SetWidth(100)
    frame.castCooldown:SetJustifyH("RIGHT")
    frame.castCooldown:SetPoint("RIGHT", frame.castBar, "RIGHT", 0, 0)
	elseif (self.maxValue-self.value)<0 then
	frame.castCooldown:SetText(" ")
	elseif UnitCastingInfo(frame.unit) then
	frame.castCooldown:SetText(format("%.1f",self.maxValue-self.value,0))
	elseif UnitChannelInfo(frame.unit) then
	frame.castCooldown:SetText(format("%.1f",self.value,0))
	end
end
end)

--被打断在姓名版施法条显示是谁打断
local interrupt = CreateFrame("Frame", nil, UIParent)
interrupt:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
interrupt:SetScript("OnEvent", function(self, event, unit)
if PlateColorDB.daduan == false then return end
local _, subevent, _, sourceGUID, sourceName, sourceFlag, _, destGUID = CombatLogGetCurrentEventInfo()
if (subevent ~= 'SPELL_INTERRUPT') then return end
if (not sourceName) then return end
local onlyname,_ = strsplit("-",sourceName) --Ambiguate(sourceName,"short")
for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
local namePlate = namePlate.UnitFrame
if UnitGUID(namePlate.unit) == destGUID then
local _,class = GetPlayerInfoByGUID(""..sourceGUID)
if class then
color = RAID_CLASS_COLORS[class].colorStr
else color = "ffFFFFFF"
end
namePlate.castBar.Text:SetText(namePlate.castBar.Text:GetText().."- ".."|c"..color..onlyname.."|r")
end
end
end)

--生命值
local hp = function(namePlateframe)
if namePlateframe:IsForbidden() then return end
if namePlateframe.unit:lower():match("nameplate")  then
local guid = UnitGUID(namePlateframe.unit)
local _, _, _, _, _, id = strsplit("-", guid or "") 
if not namePlateframe.hp then
namePlateframe.hp = namePlateframe.healthBar:CreateFontString(nil, "ARTWORK")
namePlateframe.hp:SetFont(STANDARD_TEXT_FONT, 14, 'OUTLINE')
else

local CurHealth = UnitHealth(namePlateframe.unit)
local MaxHealth = UnitHealthMax(namePlateframe.unit)
local fPer = string.format("%d",(CurHealth/MaxHealth*100)).."%"
local fPerr = string.format("%.1f",(CurHealth/MaxHealth*100)).."%"
local fCur = nil
if CurHealth > 10000 then
		fCur = string.format("%.1f",CurHealth/10000).."w"
	else
		fCur = tostring(CurHealth)
end
if PlateColorDB.hpcent then 
namePlateframe.hp:SetPoint("CENTER",5,0)
else
namePlateframe.hp:SetPoint("RIGHT",0,0)
end
namePlateframe.hp:SetScale(PlateColorDB.num)

if id == "185685" then
namePlateframe.hp:SetText(fCur.." |cff00FF00减CD|r")
elseif id == "185680" then
namePlateframe.hp:SetText(fCur.." |cff00FF00急速|r")
elseif id == "185683" then
namePlateframe.hp:SetText(fCur.." |cff00FF00隐身|r")
elseif id == "184911" then	--减CD大怪
namePlateframe.hp:SetText(fCur.." |cff00FF00减CD|r")
elseif id == "184908" then	--急速大怪
namePlateframe.hp:SetText(fCur.." |cff00FF00急速|r")
elseif id == "184910" then	--隐身大怪
namePlateframe.hp:SetText(fCur.." |cff00FF00隐身|r")
elseif PlateColorDB.DetailType == 1 then
namePlateframe.hp:SetText(fCur)
elseif PlateColorDB.DetailType == 2 then
namePlateframe.hp:SetText(fPer)
elseif PlateColorDB.DetailType == 3 then
namePlateframe.hp:SetText(fPerr)
elseif PlateColorDB.DetailType == 4 then
namePlateframe.hp:SetText(fCur.." - "..fPer)
elseif PlateColorDB.DetailType == 5 then
namePlateframe.hp:SetText(fCur.." - "..fPerr)
end
if PlateColorDB.DetailType ~= 0 and UnitName(namePlateframe.unit) ~= UnitName("Player") then
namePlateframe.hp:Show()
else
namePlateframe.hp:Hide()
end
end
end
end
hooksecurefunc("CompactUnitFrame_UpdateMaxHealth", hp)
hooksecurefunc("CompactUnitFrame_UpdateHealth", hp)

--个人资源数值
local powertext = CreateFrame("Frame")
powertext:RegisterEvent("UNIT_POWER_FREQUENT")
powertext:RegisterEvent("NAME_PLATE_UNIT_ADDED")
powertext:SetScript("OnEvent", function(self, event)
local bar = NamePlateDriverFrame:GetClassNameplateManaBar() 
local power = UnitPower("player")
local powermax = UnitPowerMax("player")
if not bar.po and not platecolorselfpowertext and bar then
bar.po = bar:CreateFontString("platecolorselfpowertext", "ARTWORK")
bar.po:SetFont(STANDARD_TEXT_FONT, 14, 'OUTLINE')
bar.po:SetPoint("CENTER",0,-1)
end
if platecolorselfpowertext then
platecolorselfpowertext:SetText(power)
platecolorselfpowertext:SetScale(PlateColorDB.mypotext)
if PlateColorDB.po == true and powermax < 200 and bar then
platecolorselfpowertext:Show()
else
platecolorselfpowertext:Hide()
end

end
end)

--光环规则
function UpdateBuffsPC(self, unit, filter, showAll)
	if 1 == 0 then return end
	if not self.isActive then
		for i = 1, BUFF_MAX_DISPLAY do
			if (self.buffList[i]) then
				self.buffList[i]:Hide();
			else
				break;
			end
		end
		return;
	end
	
	self.unit = unit;
	self.filter = filter;
	self:UpdateAnchor();
	
	if filter == "NONE" then
		for i, buff in ipairs(self.buffList) do
			buff:Hide();
		end
	else
		local buffIndex = 1;

		-- 检测该单位的全部Aura(目前 BUFF_MAX_DISPLAY = 32)
		for i = 1, BUFF_MAX_DISPLAY do
			--[[ 先检测 可偷取/驱散增益 BUFF, 用于自定的StolenFrame UI 显示
			local name, texture, count, debuffType, duration, expirationTime, caster, canStealOrPurge, nameplateShowPersonal, spellId, _, _, _, nameplateShowAll = UnitAura(unit, i, 'HELPFUL')
			if name then 
				-- 单位的全部BUFF检测完毕时，看是否有可偷取/可驱散的
				local namePlate = C_NamePlate.GetNamePlateForUnit(self.unit)
				Np_Frame = namePlate.UnitFrame
				-- 偷取/驱散buff模块 new ui
				if not Np_Frame.StolenFrame then 
					Np_Frame.StolenFrame = CreateFrame("Frame", nil, Np_Frame)
					Np_Frame.StolenFrame:SetSize(30, 30)
					Np_Frame.StolenFrame:SetPoint("BOTTOMLEFT", Np_Frame.healthBar, "BOTTOMRIGHT", 3, -3)
					Np_Frame.StolenFrame:Hide()
					
					Np_Frame.StolenFrame.Texture = Np_Frame.StolenFrame:CreateTexture(nil, "OVERLAY")
					Np_Frame.StolenFrame.Texture:SetAllPoints()
					
					Np_Frame.StolenFrame.Cooldown = CreateFrame("Cooldown", nil, Np_Frame.StolenFrame, "CooldownFrameTemplate")
					Np_Frame.StolenFrame.Cooldown:SetAllPoints()
					local regon = Np_Frame.StolenFrame.Cooldown:GetRegions()
					if regon.GetText then 
						regon:SetFont(STANDARD_TEXT_FONT, 15, "OUTLINE")
					end
					Np_Frame.StolenFrame.Cooldown:SetReverse(true)
				end
				if canStealOrPurge then 
					Np_Frame.StolenFrame:Show()
					Np_Frame.StolenFrame.Texture:SetTexture(texture)
					Np_Frame.StolenFrame.Cooldown:SetCooldown(expirationTime - duration, duration)
					if IsAddOnLoaded("WeakAuras") then
					LibStub("LibCustomGlow-1.0").PixelGlow_Start(Np_Frame.StolenFrame,{0,1,0,1}) end
					if (expirationTime-GetTime())>99 then
						Np_Frame.StolenFrame.Cooldown:SetHideCountdownNumbers(true)
					else
						Np_Frame.StolenFrame.Cooldown:SetHideCountdownNumbers(false)
					end
				else
					Np_Frame.StolenFrame:Hide()
				end
			end]]
			-- 再检测 减益DEBUFF, 用于源生buff位置显示, 源码涉及 NamePlateDriverMixin:OnUnitAuraUpdate 里filter逻辑
			local name, texture, count, debuffType, duration, expirationTime, caster, canStealOrPurge, nameplateShowPersonal, spellId, canApplyAura, _, castByPlayer, nameplateShowAll = UnitAura(unit, i, filter)
			if name then 
				if buffIndex <= 10 then 
					local flag = false
					--如果启用全部隐藏直接结束
					if PlateColorDB.hidebuff == true then return end
					-- 默认过滤器
					if nameplateShowAll == true or nameplateShowPersonal == true then
						flag = true
					end
					-- 白名单
					if PlateColorDB["DctAura"] then 
						if PlateColorDB["DctAura"][spellId] then 
							flag =  true end 
					end
					-- 只显示我,暴雪默认会显示一些
					if (not (caster == "player" or caster == "pet")) and nameplateShowAll == false then 
						flag = false
					end
					--个人资源buff
					if not PlateColorDB.myplatebuff and UnitName(unit) == UnitName("Player") then
						flag = false
					end
					--blz不显示,但是需要显示的
					if spellId == 10326 or spellId == 123586 or spellId == 228626 or spellId == 328351 or spellId == 339917 or spellId == 328501 then
					--超度邪恶10326 翔龙减速123586 彼界罐子228626 通灵矛328351 高塔矛339917 凋魂炸弹怪dot328501
					flag = true
					end
					-- 黑名单
					if PlateColorDB["blackAura"] then 
						if PlateColorDB["blackAura"][spellId] then 
							flag =  false end 
					end
					
					if (flag) then
						if (not self.buffList[buffIndex]) then
							-- self.buffList[buffIndex] = CreateFrame("Frame", self:GetParent():GetName() .. "Buff" .. buffIndex, self, "NameplateBuffButtonTemplate");
							self.buffList[buffIndex] = CreateFrame("Frame", nil, self, "NameplateBuffButtonTemplate");
							self.buffList[buffIndex]:SetMouseClickEnabled(false);
							self.buffList[buffIndex].layoutIndex = buffIndex;
							self.buffList[buffIndex].align = "right";
							if PlateColorDB.buffz > 20 then 
								self.buffList[buffIndex]:SetSize(PlateColorDB.buffz,PlateColorDB.buffz)
								self.buffList[buffIndex].Icon:SetPoint("TOPLEFT",self.buffList[buffIndex],"TOPLEFT", 1, -1)
								self.buffList[buffIndex].Icon:SetPoint("BOTTOMRIGHT",self.buffList[buffIndex],"BOTTOMRIGHT", -1, 1)
								self.buffList[buffIndex].Icon:SetTexCoord(0.1, 0.9,0.1 , 0.9)
							end
							self.buffList[buffIndex].Cooldown:SetHideCountdownNumbers(not PlateColorDB.bufftext)
							local regon = self.buffList[buffIndex].Cooldown:GetRegions()
							if regon.GetText then 
								regon:SetFont(STANDARD_TEXT_FONT,15, "OUTLINE")  --Default : 15 "OUTLINE"
							end
						end

						local buff = self.buffList[buffIndex];

						buff:SetID(i);
						buff.Icon:SetTexture(texture);

						-- 层数 
						if (count > 1) then
							buff.CountFrame.Count:SetText(count);
							buff.CountFrame.Count:Show();
						else
							buff.CountFrame.Count:Hide();
						end

						CooldownFrame_Set(buff.Cooldown, expirationTime - duration, duration, duration > 0, true);

						buff:Show();
						buffIndex = buffIndex + 1;
					end
				end
			end
		end

		for i = buffIndex, BUFF_MAX_DISPLAY do
			if (self.buffList[i]) then
				self.buffList[i]:Hide();
			end
		end
	end
	self:Layout();
end
--设置界面刷新
function PlateOPT()
for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
	local unitFrame = namePlate.UnitFrame
	unitFrame.BuffFrame.UpdateBuffs = UpdateBuffsPC
	if PlateColorDB.buffz > 20 then 
		unitFrame.BuffFrame:SetBaseYOffset((PlateColorDB.buffz-18*PlateColorDB.nScale)+PlateColorDB.buffoffset*2)
		unitFrame.BuffFrame:UpdateAnchor()
	end
	if unitFrame.unit then 
		local buff = unitFrame.BuffFrame
		for i = 1, BUFF_MAX_DISPLAY do
			if buff.buffList[i] then 
				if PlateColorDB.buffz > 20 then 
				--光环大小
					buff.buffList[i]:SetSize(PlateColorDB.buffz,PlateColorDB.buffz)
					buff.buffList[i].Icon:SetPoint("TOPLEFT",buff.buffList[i],"TOPLEFT", 1, -1)
					buff.buffList[i].Icon:SetPoint("BOTTOMRIGHT",buff.buffList[i],"BOTTOMRIGHT", -1, 1)
				end
				--计时器
				buff.buffList[i].Cooldown:SetHideCountdownNumbers(not PlateColorDB.bufftext)
				--计时器大小
				local regon = buff.buffList[i].Cooldown:GetRegions()
				if regon.GetText then 
					regon:SetFont(STANDARD_TEXT_FONT,15, "OUTLINE")  --Default : 15 "OUTLINE"
				end
			end
		end
	end
end
end
--光环相关设置
local framebuff = CreateFrame('Frame')
framebuff:RegisterEvent("NAME_PLATE_UNIT_ADDED")
framebuff:SetScript('OnEvent', function(self, event, namePlateUnitToken)
local namePlate = C_NamePlate.GetNamePlateForUnit(namePlateUnitToken)
local unitFrame = namePlate.UnitFrame
	unitFrame.BuffFrame.UpdateBuffs = UpdateBuffsPC
	if PlateColorDB.buffz > 20 then 
		unitFrame.BuffFrame:SetBaseYOffset((PlateColorDB.buffz-18*PlateColorDB.nScale)+PlateColorDB.buffoffset*2)
		unitFrame.BuffFrame:UpdateAnchor()
	end
	if unitFrame.unit then 
		local buff = unitFrame.BuffFrame
		for i = 1, BUFF_MAX_DISPLAY do
			if buff.buffList[i] then 
				if PlateColorDB.buffz > 20 then 
				--光环大小
					buff.buffList[i]:SetSize(PlateColorDB.buffz,PlateColorDB.buffz)
					buff.buffList[i].Icon:SetPoint("TOPLEFT",buff.buffList[i],"TOPLEFT", 1, -1)
					buff.buffList[i].Icon:SetPoint("BOTTOMRIGHT",buff.buffList[i],"BOTTOMRIGHT", -1, 1)
				end
				--计时器
				buff.buffList[i].Cooldown:SetHideCountdownNumbers(not PlateColorDB.bufftext)
				--计时器大小
				local regon = buff.buffList[i].Cooldown:GetRegions()
				if regon.GetText then 
					regon:SetFont(STANDARD_TEXT_FONT,15, "OUTLINE")  --Default : 15 "OUTLINE"
				end
			end
		end
	end
end)

--易爆打球
local function BoomBall()
	local haskey = false
	for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
		local unitFrame = namePlate.UnitFrame
		local guid = UnitGUID(unitFrame.unit)
		local _, _, _, _, _, id = strsplit("-", guid or "") 
		if id == "120651" then
			haskey = true
		end
	end	
	-- 场上存在易爆球
	if haskey then 
			for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
				local unitFrame = namePlate.UnitFrame
				local guid = UnitGUID(unitFrame.unit)
				local _, _, _, _, _, id = strsplit("-", guid or "") 
				if id ~= "120651" and UnitCastingInfo(unitFrame.unit) == nil and UnitChannelInfo(unitFrame.unit) == nil and not UnitIsUnit(unitFrame.displayedUnit, "target") then
					unitFrame:Hide()
				else
					unitFrame:Show()
				end
			end
	else
			for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
				local unitFrame = namePlate.UnitFrame
				unitFrame:Show()
			end
	end
end
local boomFrame = CreateFrame("Frame")
local timei = 0 
boomFrame:SetScript("OnUpdate", function (self, elasped)
	if PlateColorDB.boom ~= true then return end
	local level, affixes = C_ChallengeMode.GetActiveKeystoneInfo()
	if level < 7 then return end
	if affixes[3] ~= 13 then return end
	timei = timei + elasped
	if timei > 0.2 then
		BoomBall()
		timei = 0
	end
end)